from __future__ import division
import os, sys, math, copy, time
sys.path = ["/home/prime/Downloads/buildRoot/lib/"] + sys.path
from ROOT import *
from ROOT.RooStats import *
import os, sys, math, copy, time
from ROOT.RooFit import LineColor, LineStyle
from ROOT import RooRealVar, TFile, TH1D, RooGaussian, RooExtendPdf
from ROOT import gROOT


################################################################################
# load intepolation module:
gROOT.LoadMacro("simpleHist.h")
from ROOT import simpleHist
################################################################################

# setup variables
fitMin=0
fitMax=10e3 # when the fitRange matches the x's range, no problem
fitMax=5e3  # when the fitRange is a subset of x's range, get infinite loop
x        = RooRealVar("x","x",0,0,10e3);
m2       = RooRealVar("m2","m2",-3e3);
m1       = RooRealVar("m1","m1",-2e3);
# load histogram for test pdf shape
# f = TFile.Open("allData.root")
f = TFile.Open("data.root")
hist = f.Get("diff_CI_LL_const_10_TeV")


# "exp" is just a shape to use in RooAddPdf
exp = RooExponential("expo1","expo1",x,m1);

# "testPdf" is the what I want to get working
testPdf = simpleHist("f","f",x,hist)
# You can replace testPdf with an exponential as a test
# testPdf      = RooExponential("expo2","expo2",x,m2);

# Extend pdfs in a range called fitRange
x.setRange("fitRange",fitMin,fitMax)
x.setBins(100)
expNorm       = RooRealVar("expNorm","expNorm",1);
testPdfNorm   = RooRealVar("testPdfNorm","testPdfNorm",1);
expExtFit     = RooExtendPdf("expExt","expExt",exp,expNorm,"fitRange")
testPdfExtFit = RooExtendPdf("testPdfExt","testPdfExt",testPdf,testPdfNorm,"fitRange")
# added pdf
addedPdfs     = RooAddPdf(  
                      "pdf","pdf",
                      RooArgList(testPdfExtFit,expExtFit),
                      RooArgList(testPdfNorm,expNorm),
                    )
addedPdfs.fixAddCoefRange("fitRange",True)
addedPdfs.fixAddCoefNormalization(RooArgSet(x),True)

# this is the line that causes the problem - I see it as an infinite loop of 
# testPdf's evaluate getting called
print addedPdfs.getVal()

print "DONE"; quit()

